using System;

namespace Quik.FreeType
{
    public struct FT_BBox_
    {
        public long xMin, yMin;
        public long xMax, yMax;
    }

    public struct FT_Generic_
    {
        public IntPtr Data;
        public IntPtr Finalizer;
    }

    public struct FT_Matrix_
    {
        public long xx, xy;
        public long yx, yy;
    }

    public struct FT_Vector_
    {
        public long x;
        public long y;
    }

    public struct FT_MemoryRec_
    {
        public IntPtr User;
        public IntPtr Alloc;
        public IntPtr Free;
        public IntPtr Realloc;
    }

    public struct FT_StreamRec_
    {
        public IntPtr Base;
        public long Size;
        public long Position;
        public IntPtr Descriptor;
        public IntPtr Read;
        public IntPtr Close;
        public IntPtr Memory;
        public IntPtr Cursor;
        public IntPtr Limit;
    }

    public struct FT_ListRec_
    {
        public IntPtr Head;
        public IntPtr Tail;
    }

    public enum FT_Glyph_Format_
    {
        None        = 0,
        Composite   = 1668246896,
        Bitmap      = 1651078259,
        Outline     = 1869968492,
        Plotter     = 1886154612,
        Svg         = 1398163232,
    }

    public struct FT_Bitmap_
    {
        public int rows;
        public int width;
        public int pitch;
        public IntPtr Buffer;
        public short NumGrays;
        public byte pixel_mode;
        public byte palette_mode;
        public IntPtr Palette;
    }

    public struct FT_Outline_
    {
        public short n_contours;
        public short n_points;
        public IntPtr Points;
        public IntPtr Tags;
        public IntPtr Contours;
        public int Flags;
    }
}